//+------------------------------------------------------------------+
//|                                               SuperTrend nrp.mq4 |
//|                                                                  |
//| original Super trend for metatrader made by Jason Robinson       |
//| calculation correction, repainting solving and mtf by mladen     |
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 5
#property indicator_color1 DeepSkyBlue
#property indicator_color2 PaleVioletRed
#property indicator_color3 DeepSkyBlue
#property indicator_color4 PaleVioletRed
#property indicator_color5 PaleVioletRed
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    atrPeriod        = 60;
extern double atrMultiplier    = 2.00;
extern bool   Interpolate      = true;
extern bool   DrawColorLines   = false;
extern bool   DrawColorBars    = true;

extern string _                = "alerts settings";
extern bool   alertsOn         = false;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

extern string LabelID          = "SuperTrendBars1";
extern string LabelText        = "Super trend bars";
extern color  LabelColor       = DarkGray;
extern int    LabelWindow      = 0;
extern int    LabelCorner      = 3;
extern int    LabelXPos        = 10;
extern int    LabelYPos        = 10;
extern string LabelFontName    = "Arial";
extern int    LabelFontSize    = 10;

//
//
//
//
//

double Trend[];
double STrendHu[];
double STrendHd[];
double TrendDa[];
double TrendDb[];
double Up[];
double Dn[];
double Direction[];

//
//
//
//
//

int    timeFrame;
string IndicatorFileName;
bool   ReturningBars;
bool   CalculatingStr;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   int style = DRAW_NONE; if (DrawColorBars) style = DRAW_HISTOGRAM;
   IndicatorBuffers(8);
      SetIndexBuffer(0, STrendHu);  SetIndexStyle(0,style); SetIndexLabel(0,"SuperTrend");
      SetIndexBuffer(1, STrendHd);  SetIndexStyle(1,style); SetIndexLabel(1,"SuperTrend");
      
      style = DRAW_NONE; if (DrawColorLines) style = DRAW_LINE;
      
      SetIndexBuffer(2, Trend);    SetIndexStyle(2,style); SetIndexLabel(2,"SuperTrend");
      SetIndexBuffer(3, TrendDa);  SetIndexStyle(3,style); SetIndexLabel(3,"SuperTrend");
      SetIndexBuffer(4, TrendDb);  SetIndexStyle(4,style); SetIndexLabel(4,"SuperTrend");
      SetIndexBuffer(5, Up);
      SetIndexBuffer(6, Dn);
      SetIndexBuffer(7, Direction);

      //
      //
      //
      //
      //
         
         IndicatorFileName = WindowExpertName();
         CalculatingStr    = (TimeFrame=="CalculateStr"); if (CalculatingStr) return(0);
         ReturningBars     = (TimeFrame=="returnBars");   if (ReturningBars)  return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         
      //
      //
      //
      //
      //
   
   IndicatorShortName("SuperTrend "+timeFrameToString(timeFrame));    
return(0);
}

int deinit()
{
   ObjectDelete(LabelID);
   return(0);
}




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int limit,i;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (ReturningBars) { Trend[0] = limit+1; return(0); }
         if (!CalculatingStr)
         {
            if (ObjectFind(LabelID)<0) 
               ObjectCreate(LabelID,OBJ_LABEL,LabelWindow,0,0,0);
                  ObjectSet(LabelID,OBJPROP_COLOR,LabelColor);
                  ObjectSet(LabelID,OBJPROP_CORNER,LabelCorner);
                  ObjectSet(LabelID,OBJPROP_XDISTANCE,LabelXPos);
                  ObjectSet(LabelID,OBJPROP_YDISTANCE,LabelYPos);
                  ObjectSetText(LabelID,LabelText,LabelFontSize,LabelFontName,LabelColor);
         }
   //
   //
   //
   //
   //

   if (CalculatingStr || timeFrame==Period())
   {      
      if (!CalculatingStr && Direction[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
      for(i=limit; i>=0; i--)
      {
         double atr    = iATR(NULL,0,atrPeriod,i);
         double cprice = Close[i];
         double mprice = iMA(NULL,0,1,0,MODE_SMA,PRICE_MEDIAN,i);
                Up[i]  = mprice+atrMultiplier*atr;
                Dn[i]  = mprice-atrMultiplier*atr;
         
         //
         //
         //
         //
         //

         TrendDa[i] = EMPTY_VALUE;
         TrendDb[i] = EMPTY_VALUE;
         Direction[i] = Direction[i+1];
            if (cprice > Up[i+1]) Direction[i] =  1;
            if (cprice < Dn[i+1]) Direction[i] = -1;
            if (Direction[i] > 0) { Dn[i] = MathMax(Dn[i],Dn[i+1]); Trend[i] = Dn[i]; STrendHu[i] = High[i];  STrendHd[i] = Low[i]; }
            else                  { Up[i] = MathMin(Up[i],Up[i+1]); Trend[i] = Up[i]; STrendHd[i] = High[i];  STrendHu[i] = Low[i]; }
            if (Direction[i]==-1) PlotPoint(i,TrendDa,TrendDb,Trend);
            
            //
            //
            //
            //
            //
            
            if (!CalculatingStr && Direction[limit]==-1) PlotPoint(i,TrendDa,TrendDb,Trend);
            
      }
      manageAlerts();
      return(0);
   }

   //
   //
   //
   //
   //
   
   if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   if (Direction[limit]==-1) CleanPoint(limit,TrendDa,TrendDb);
   for (i=limit;i>=0;i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         Direction[i] = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",atrPeriod,atrMultiplier,7,y);
         Trend[i]     = iCustom(NULL,timeFrame,IndicatorFileName,"CalculateStr",atrPeriod,atrMultiplier,2,y);
         TrendDa[i] = EMPTY_VALUE;
         TrendDb[i] = EMPTY_VALUE;
            if (Direction[i] ==  1) { STrendHu[i] = High[i];  STrendHd[i] = Low[i]; }
            if (Direction[i] == -1) { STrendHd[i] = High[i];  STrendHu[i] = Low[i]; }

         //
         //
         //
         //
         //
      
         if (timeFrame <= Period() || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;
         if (!Interpolate) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            double factor = 1.0 / n;
            for(int k = 1; k < n; k++) Trend[i+k] = k*factor*Trend[i+n] + (1.0-k*factor)*Trend[i];
   }
   for (i=limit;i>=0;i--) if (Direction[i] == -1) PlotPoint(i,TrendDa,TrendDb,Trend);
   manageAlerts();
   return(0);
}



void manageAlerts()
{
   if (!CalculatingStr && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (Trend[whichBar] != Trend[whichBar+1])
      {
         if (Trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (Trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(timeFrame)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SuperTrend changed direction to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SuperTrend "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
      if (first[i+2] == EMPTY_VALUE) {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
         }
      else {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
         }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}